function AA=to3Darray(A,dims)
  assert( length(dims)==3 )
  N=dims(1);m=dims(2);n=dims(3);
  if length(size(A))==2
    if all( size(A)==[1,1] ),AA=A;return;end
    if all( size(A)==[N,1] ) %size(A,1)==N && size(A,2)==1 
      AA=repmat(A,1,m,n);
      return 
    end
    if all( size(A)==[1,N] ) %size(A,1)==1 && size(A,2)==N
      AA=repmat(A.',1,m,n);
      return 
    end
    if all( size(A)==[N,1] ) %size(A,1)==N && size(A,2)==1
      disp('AAAA')
      AA=repmat(A,1,m,n);
      return 
    end
    if all( size(A)==[m,n] ) %size(A,1)==m && size(A,2)==n
      AA=permute(repmat(A,1,1,N),[3,1,2]);
      return
    end
    if all( size(A)==[1,1] ) %size(A,1)==1 && size(A,2)==1
      AA=A*ones(N,m,n);
      return 
    end
    error('Unable to convert array (%d,%d) in a 3Darray (%d,%d,%d)',size(A,1),size(A,2),N,m,n)
  end
  assert( all(size(A)==[N,m,n]) ,'3Darray size failed')
  AA=A;
  AA=redim(AA,[N,m,n]); % for compatibily with Matlab < 2016b
end

function X=redim(X,dims) % 
  
  if ~fc_tools.comp.isOctave() && verLessThan('matlab','9.1.0')
    nX=ndims(X);sX=size(X);
    if nX==2 && all(sX==[1 1]), return;end % X scalar
    assert(length(dims)==3)
    if size(X,1)~=dims(1)   % X is m-by-n or 1-by-n or m-by-1
      X=reshape(X,[1 size(X)]);
    end
    sX=size(X);
    irp=[1 1 1];
    if sX(1)==1, irp(1)=dims(1);end
    if sX(2)==1, irp(2)=dims(2);end
    if ndims(X)==2 
      irp(3)=dims(3);
    elseif sX(3)==1 
      irp(3)=dims(3);
    end
    X=repmat(X,irp);
  else
    if size(X,1)~=dims(1)   % X is m-by-n or 1-by-n or m-by-1
      X=reshape(X,[1 size(X)]);
    end
  end
end
